class AdminController < ApplicationController
  def index
    list
    render :action => 'list'
  end

  # GETs should be safe (see http://www.w3.org/2001/tag/doc/whenToUseGet.html)
  verify :method => :post, :only => [ :destroy, :create, :update ],
         :redirect_to => { :action => :list }

  def list
  end

  def show
    @article = Article.find(params[:id])
  end

  def new
    @article = Article.new
  end

  def create
    @article = Article.new(params[:article])
    if @article.save
      flash[:notice] = 'Article was successfully created.'
      redirect_to :action => 'list'
    else
      render :action => 'new'
    end
  end

  def edit
    @article = Article.find(params[:id])
    render :layout => false
  end

  def update
    @article = Article.find(params[:id])
    if @article.update_attributes(params[:article])
      flash[:notice] = 'Article was successfully updated.'
      redirect_to :action => 'show', :id => @article
    else
      render :action => 'edit'
    end
  end

  def destroy
    Article.find(params[:id]).destroy
    redirect_to :action => 'list'
  end
  
  def edit_settings
    if request.post?
      if @blog.update_attributes(params[:blog])
        flash[:notice] = "Blog settings updated."
        redirect_to :action => 'index'
      else
        render :action => 'edit_settings'
      end
    end
  end
  
  before_filter :article_list, :authenticate, :username
  
  private
  
  def article_list
    @article_pages, @articles = paginate :articles, :per_page => 10
  end
  
  def authenticate
    unless session["user"]
      redirect_to :controller => "login"
    end
  end
  
  def username
    @user = session["user"]
  end
  
end
